/*
	
	FontView.h
	
	Copyright 1998 HAMANAKA Makoto, All Rights Reserved.
	
*/

#ifndef FONT_VIEW_H
#define FONT_VIEW_H

#ifndef _CONTROL_H
#include <Control.h>
#endif
#ifndef _MESSAGE_H
#include <Message.h>
#endif
#ifndef _FONT_H
#include <Font.h>
#endif
#ifndef _POPUP_MENU_H
#include <PopUpMenu.h>
#endif
#ifndef _TRANSLATOR_ROSTER_H
#include <TranslatorRoster.h>
#endif
#ifndef _STRING_H
#include <string.h>
#endif

#ifndef FONT_WORLD_H
#include "FontWorld.h"
#endif
#ifndef FONT_DISPLAY_SETTING_H
#include "FontDisplaySetting.h"
#endif

#define FONT_ITEM_HEIGHT 48
#define FONT_DEFAULT_FONT_SIZE 48

#define FONTVIEW_SHOW_LINES_FLAG 0x01
#define FONTITEM_OFFSET_LEFT_DEFAULT 180.0

//#include <algorithm>
//#include <map>
//#include <string>

//using namespace std;

//typedef multimap<string, pair<translator_id, int32> > MimetypeTranslatorMap;

class FontView : public BControl
{
	
	pbfont_stl_vector &fonts;
//	BFont **fonts;
	int32 fonts_num;
	BScrollView *scroller;
	char *text;
	int32 font_item_height;
	int32 fontsize;
	int32 font_drawing_mode;
	bool is_antialiasing_disabled;
	bool is_required_to_adjust_scroll_ranges;
	int32 selected_item_index;
	BPopUpMenu *popupmenu;
	rgb_color fgcolor,bgcolor;

	double fontitem_offset_left;

//	translator_id translator;
//	uint32 translator_type_code;
//	char translator_type_string[256];
	string drag_clip_suffix;
	string drag_clip_mime_type;
	
	
/*	translator_id * all_translators;
	int all_translators_num;
	char **all_translators_output_type_strings;
	int all_translators_output_types_num;
*/
//	MimetypeTranslatorMap translators_map;
	BBitmap *background_bitmap;
	string dnd_output_format;

public:
	FontView(BRect rect, const char *name, const char *label,
					BMessage *message, pbfont_stl_vector &fonts);
//	FontView(BRect frame, const char *name ,const char *label ,BMessage *message, BFont **fonts, int32 fonts_num); 
	virtual ~FontView();
	virtual void ApplySetting(FontDisplaySetting *_setting);
	virtual void StoreSetting(FontDisplaySetting *_setting);
	virtual void Draw(BRect updateRect);
	virtual void DrawAnFontItem(int index);
	virtual void FrameMoved(BPoint parentPoint);
	virtual void FrameResized(float width, float height);
	virtual void TargetedByScrollView(BScrollView *scroller1);
	virtual void SetText(const char *new_text);
	virtual void SetFGColor(rgb_color _color);
	virtual void SetBGColor(rgb_color _color);
	virtual char *Text();
	virtual void SetTextFontSize(int32 new_font_size);
	virtual void SetFonts(pbfont_stl_vector &fonts);
	virtual void AdjustScrollRanges();
	virtual void AttachedToWindow(void);
//	virtual void MakeFocus(bool focused = true);
	virtual void MouseDown(BPoint point);
	virtual void SetPopUpMenu(BPopUpMenu *new_popupmenu);
	virtual int32 GetFontIndexOnLocation(BPoint point);
	virtual BFont *GetFontByIndex(int32 index);
	virtual void DisableAntialiasing(bool new_mode);
	virtual bool IsAntialiasingEnabled();
	virtual void SetFontDrawingMode(int32 new_mode);
	virtual int32 FontDrawingMode(void);
	virtual BRect GetBoundsByIndex(int32 index);
	virtual bool MouseDownToDrag(BPoint where);
	virtual BBitmap *CreateStringBitmap(BFont *font, BRect rect, char *text,
			 rgb_color high_color, rgb_color low_color, BPoint offset = BPoint(0,0) , bool transparent_mode = false);
	virtual void ActionCopy(BMessage * request);
	virtual void MessageReceived(BMessage *message);
//	virtual void InitTranslators();
	virtual void SetDnDOutputFormat(const char *type);
};

#endif //FONT_VIEW_H
