/*

	FontWorld v0.51

	FontWorld.cpp
	Copyright 1998-1999 HAMANAKA Makoto

	TODO: multiple settings
	TODO: background selection dialog
	TODO: add capability to drop image to ShowImage
	TODO: add capability to change shear
	TODO: change system fonts
	TODO: change system font cache size
	TODO: change fore/back color
	TODO: ability to specify & save my favorite fonts ( font folder )
	TODO: mini window
	TODO: japanese font only mode
	TODO: font furiwake function
	  (this font is Japanese ,so move it to this folder, or... )
	TODO: add capability of change width of names of these font's family/style
	
	TODO: auto-scroll?

	*** IMPORTANT ***
	To run this application smoother,
	I recommend you to change your system's
	font cache size to be over 1 Megabytes.
	
	(system default is 200kb or so? - very insufficient for this application.)
	You can change font cache size by deskbar - preferences - Fonts .

	v0.561 2000/8/23
		fix minor bug( "Save Setting" will not make valid data at first save )
	v0.56 2000/8/21
		Add feature Choose FG\BG Color
		Kill auto-save.
			instead, add "Save Current Setting" to Option Menu.
	v0.55 2000/8/20
		Add feature - auto Save/Load Settings
			Preliminary implementation
			only 1 setting
			auto-save current setting at closing app.
			auto-load previous setting at opening app.
		(it will be extended to named-multiple-settings some day...)
	v0.511 1999/5/22
	    add Japanese font only mode ... doesn't work ;-)
	v0.51 1999/5/3
		add MenuField to choose output-format(.bmp, .jpg etc)
		background image test
		(put 'image' file on the folder where FontWorld excutable exists.)
		Menu : 'Exit' => 'Quit ALT+Q' and About... moved
		

	v0.502 1999/4/29
		add font size up/down button

	v0.501 1999/4/27
		output any format(with translator)
		but still can't paste image to app 'ShowImage'

	v0.50 1999/4/25
		fix bug (not show green(ascent) line)
		fix bug (bad big-step value of scrollbar)
		drag & drop font image to Tracker(only targa format now)
	       <please look at cool translucent image when dragging!>
		
	v0.44 1999/4/18
		port to R4
		some change on layout
		change slider values
		change default font size to 16
		change default window size
		new application icon
	
	v0.43 1998/8/11
		be able to keep looking at a perticuler font when fontsize was changed.

	v0.42 1998/8/6
		switch on/off antialiasing
		switch on/off lines

	v0.41 1998/8/4
		add ascent/descent/leading to Font Info
		used STL.

	v0.4 (preview release) 1998/8/1 
		add popup menu -> display font infomation
		ascend & descend
		some changes in item size
		
	v0.3 1998/7/30
		add fontsize BTextControl
		add colors(no function now)
		adjust view size when changing font size

	v0.2 1998/7/29
		rough
	
	Known Bugs
	fixed : v0.44 Ascent Line(green) not displayed properly
	fixed : v0.44 Scroll up/down not proper(sometimes go backward!!)
	
	
*/

#ifndef FONT_WINDOW_H
#include "FontWindow.h"
#endif
#ifndef FONT_WORLD_H
#include "FontWorld.h"
#endif
#ifndef FONT_VIEW_H
#include "FontView.h"
#endif
#ifndef FONT_WORLD_CONFIG_H
#include "FontWorldConfig.h"
#endif
#ifndef COLOR_VIEW_H
#include "ColorView.h"
#endif

#include <stdio.h>
#include <Resources.h>
#include <UnicodeBlockObjects.h>

status_t count_fonts(BFont **fonts, int32 buff_len, int32 *length);
void count_fonts2(pbfont_stl_vector &fonts);
void count_fonts_only_japanese(pbfont_stl_vector &fonts);

FontApplication	*myApp;

int main(void)
{
//	FontWorldConfig::test();

	myApp = new FontApplication();
	myApp->Run();
	delete myApp;

	return(0);
}

FontApplication::~FontApplication()
{
	pbfonts_stl_list::iterator i;
	for (i = fonts_lib -> begin() ; i != fonts_lib -> end() ; i++)
	{
		pbfont_stl_vector * ifonts = (*i);
		pbfont_stl_vector::iterator ii;
		for (ii = ifonts->begin() ; ii < ifonts->end() ; ii++)
		{
			BFont * pbfont = (*ii);
			delete pbfont;
		}
		delete ifonts;
	}
	delete fonts_lib;
}

FontApplication::FontApplication()
		  		  : BApplication("application/x-vnd.HM-FontWorld")
		  		  , aView(NULL)
		  		  , textControl(NULL)
		  		  , textControl2(NULL)
		  		  , slider(NULL)
		  		  , output_format_menu(NULL)
		  		  , fonts_lib(NULL)
		  		  , setting()
		  		  , color_control_window_FG(NULL)
		  		  , color_control_window_BG(NULL)
		  		  , color_control_FG(NULL)
		  		  , color_control_BG(NULL)
{
	FontWindow		*aWindow;
	BRect			aRect;

	LoadConfig();
//
fonts_lib = new pbfonts_stl_list();

	pbfont_stl_vector *pfonts = new pbfont_stl_vector();
	pbfont_stl_vector *pfonts_jp = new pbfont_stl_vector();
	if (pfonts == NULL) return;
	pbfont_stl_vector &fonts = *pfonts;
	pbfont_stl_vector &fonts_jp = *pfonts_jp;
	
	count_fonts2(fonts);
	count_fonts_only_japanese(fonts_jp);

//	TODO: 
fonts_lib->push_back(pfonts);
fonts_lib->push_back(pfonts_jp);
	
#ifdef DEBUG
	for (pbfont_stl_vector::iterator i = fonts.begin() ; i<fonts.end() ; i++)
	{
		(*i) -> PrintToStream();
	}
#endif

	this->InitTranslators();

//----------------------
//  make window
//

	// set up a rectangle and instantiate a new window
	aRect.Set(50, 50, 800/*550*/, 460);
	aWindow = new FontWindow(aRect);

//----------------------
//   add MenuBar
//
	BRect menubarrect(0,0,200,40); // iikagen
	BMenuBar *menubar = new BMenuBar(menubarrect,"menu1");
	BMenuItem *item;
	BMenu *menu;
	
	menu = new BMenu("File");
//		item = new BMenuItem("Save in jpeg...",new BMessage(B_ABOUT_REQUESTED));
//		menu->AddItem(item);
		item = new BMenuItem("About FontWorld..." B_UTF8_ELLIPSIS, 
                                new BMessage(B_ABOUT_REQUESTED));
		item->SetTarget(this);
		menu->AddItem(item);
		menu->AddItem(new BSeparatorItem());
		item = new BMenuItem("Quit",new BMessage(B_QUIT_REQUESTED),'Q');
		menu->AddItem(item);
	menubar->AddItem(menu);
	menu = new BMenu("Option");
//		item = new BMenuItem("Update Font List",new BMessage(____));
//		menu->AddItem(item);
		item = new BMenuItem("Enable Antialiasing",new BMessage(MENU_ANTIALIAS));
		if (this->setting.enable_antialiasing)
			item->SetMarked(true);
		item->SetTarget(this);
		menu->AddItem(item);
		item = new BMenuItem("Enable Lines",new BMessage(MENU_SHOW_LINES));
		if (this->setting.enable_display_lines)
			item->SetMarked(true);
		item->SetTarget(this);
		menu->AddItem(item);
		menu->AddSeparatorItem();
		item = new BMenuItem("Save Current Setting",new BMessage(MENU_SAVE_SETTING));
		item->SetTarget(this);
		menu->AddItem(item);
		
		/*
		item = new BMenuItem("Load Default Setting",new BMessage(MENU_LOAD_DEFAULT_SETTING));
		item->SetTarget(this);
		menu->AddItem(item);
		*/
/*
		item = new BMenuItem("Japanses Only",new BMessage(MENU_ONLY_JAPANESE));
		item->SetMarked(false);
		item->SetTarget(this);
		menu->AddItem(item);
*/
/*
		item = new BMenuItem("Select Background...",new BMessage(MENU_BACKGROUND_SELECT));
		item->SetTarget(this);
		menu->AddItem(item);
*/
	menubar->AddItem(menu);

/*	menu = new BMenu("OutputFormat");
		menu->SetRadioMode(true);
		menu->SetLabelFromMarked(true);
		item = new BMenuItem(".bmp",new BMessage(MENU_BITMAP_OUTPUT_FORMAT));
		menu->AddItem(item);
		item = new BMenuItem(".tga",new BMessage(MENU_BITMAP_OUTPUT_FORMAT));
		menu->AddItem(item);
		item = new BMenuItem(".jpg",new BMessage(MENU_BITMAP_OUTPUT_FORMAT));
		menu->AddItem(item);
		item = new BMenuItem(".*",new BMessage(MENU_BITMAP_OUTPUT_FORMAT));
		menu->AddItem(item);
	menubar->AddItem(menu);
*/    
    
	aWindow->SetKeyMenuBar(menubar);
	aWindow->AddChild(menubar);

//----------------------
//   add TextControl
//
	BRect aRectTC;
	aRectTC.top  = 10;
	aRectTC.left = 10;
	aRectTC.right  = aRectTC.left + 300;
	aRectTC.bottom = aRectTC.top  + 20;
	
	BMessage *message = new BMessage(FONT_TEXT_CHANGE);
	textControl = new BTextControl(aRectTC, "textcontrol1", "Text :", STARTUP_TEXT, message);
	textControl->SetDivider(40);
	textControl->SetTarget(this);
//	aWindow->AddChild(textControl);
	
//----------------------
//   add TextControl2(fontsize)
//
	BRect aRectTC2;
	aRectTC2.top  = 34;
	aRectTC2.left = 10;
	aRectTC2.right  = aRectTC2.left + 80;
	aRectTC2.bottom = aRectTC2.top  + 20;
	
	BMessage *messageTC2 = new BMessage(FONT_TEXT_SIZE_CHANGE2);
	char text[10];
	sprintf(text,"%ld",(int32)this->setting.font_size);
	textControl2 = new BTextControl(aRectTC2, "textcontrol2", "Size :", text, messageTC2);
	textControl2->SetDivider(40);
	textControl2->SetTarget(this);
//	aWindow->AddChild(textControl);

//--------------------------
//   add Button (FontSize up/down)
//

	BPictureButton *button_fontsize_up;
	BPictureButton *button_fontsize_down;

	BMessage *messageFSUP = new BMessage(FONT_TEXT_SIZE_UP);
	BMessage *messageFSDN = new BMessage(FONT_TEXT_SIZE_DOWN);

	BRect aRectBT_FSU;
	aRectBT_FSU.top  = 35;
	aRectBT_FSU.left = 92;
	aRectBT_FSU.right  = aRectBT_FSU.left + 14.0;
	aRectBT_FSU.bottom = aRectBT_FSU.top  + 9.0;

	BRect aRectBT_FSD;
	aRectBT_FSD.top  = 45;
	aRectBT_FSD.left = 92;
	aRectBT_FSD.right  = aRectBT_FSD.left + 14.0;
	aRectBT_FSD.bottom = aRectBT_FSD.top  + 9.0;
	{
		BPicture *fs_up_onpic = 0;
		BPicture *fs_up_offpic = 0;
		BPicture *fs_down_onpic = 0;
		BPicture *fs_down_offpic = 0;

		BRect r_bmp = aRectBT_FSU;
		r_bmp.OffsetTo(0,0);
		BBitmap button_fontsize_up_bmp(r_bmp,B_CMAP8, true);
		BView drawview(r_bmp, "draw_to_bmp", B_FOLLOW_NONE, B_WILL_DRAW);

		if (button_fontsize_up_bmp.Lock())
		{
			button_fontsize_up_bmp.AddChild(&drawview);
			BPoint up_points[3];
			up_points[0].Set(7.0, 3);
			up_points[1].Set(4.0, 6);
			up_points[2].Set(10.0, 6);
	
			BPoint down_points[3];
			down_points[0].Set(7.0, 6);
			down_points[1].Set(4.0, 3);
			down_points[2].Set(10.0, 3);
			
			drawview.BeginPicture(new BPicture);
			drawButtonBackground(&drawview, r_bmp, true);
			drawview.SetHighColor(0,0,0);
			drawview.FillPolygon(up_points, 3, B_SOLID_HIGH);
			fs_up_onpic = drawview.EndPicture();
	
			drawview.BeginPicture(new BPicture);
			drawButtonBackground(&drawview, r_bmp, false);
			drawview.SetHighColor(0,0,0);
			drawview.FillPolygon(up_points, 3, B_SOLID_HIGH);
			fs_up_offpic = drawview.EndPicture();
	
			drawview.BeginPicture(new BPicture);
			drawButtonBackground(&drawview, r_bmp, true);
			drawview.SetHighColor(0,0,0);
			drawview.FillPolygon(down_points, 3, B_SOLID_HIGH);
			fs_down_onpic = drawview.EndPicture();
	
			drawview.BeginPicture(new BPicture);
			drawButtonBackground(&drawview, r_bmp, false);
			drawview.SetHighColor(0,0,0);
			drawview.FillPolygon(down_points, 3, B_SOLID_HIGH);
			fs_down_offpic = drawview.EndPicture();
	
			button_fontsize_up_bmp.RemoveChild(&drawview);
			button_fontsize_up_bmp.Unlock();
		}
		button_fontsize_up = new BPictureButton(aRectBT_FSU,"button_fontsize_up", fs_up_onpic, fs_up_offpic, messageFSUP);
		button_fontsize_down = new BPictureButton(aRectBT_FSD,"button_fontsize_down", fs_down_onpic, fs_down_offpic, messageFSDN);
		button_fontsize_up->SetTarget(this);
		button_fontsize_down->SetTarget(this);
	}


//--------------------------
//   add Slider (FontSize)
//

	BRect aRectSL;
	aRectSL.top  = 34;
	aRectSL.left = 108;/*96*/
	aRectSL.right  = aRectSL.left + 200;/*210*/
	aRectSL.bottom = aRectSL.top  + 20;

	BMessage *messageSL = new BMessage(FONT_TEXT_SIZE_CHANGE);
	slider = new BSlider(aRectSL, "fontsize_slider", NULL,messageSL, 10, 60);//, B_TRIANGLE_THUMB);
	slider->SetTarget(this);
	slider->SetValue((int32)this->setting.font_size);
	slider->SetLimitLabels("10 point", "60");
	slider->SetHashMarks(B_HASH_MARKS_BOTH); 
    slider->SetHashMarkCount(6);
//	aWindow->AddChild(slider);

//----------------------------------
//   output image format selector
//
	BMenu *menuOFM = new BMenu("OutputFormat");
		menuOFM->SetRadioMode(true);
		menuOFM->SetLabelFromMarked(true);

		BMessage *mes;
		mes = new BMessage(MENU_BITMAP_OUTPUT_FORMAT);
		mes->AddString("format","auto");
		item = new BMenuItem("auto",mes);
		item->SetTarget(this);
		menuOFM->AddItem(item);
		item->SetMarked(true);

		MimetypeTranslatorMap::iterator it;
		for (it = this->translators_map.begin() ; it != this->translators_map.end() ; it++)
		{
			if (it->first == "image/x-be-bitmap") continue;
			const char *type = (it->first).c_str();

			mes = new BMessage(MENU_BITMAP_OUTPUT_FORMAT);
			mes->AddString("format",type);
			item = new BMenuItem(type,mes);
			item->SetTarget(this);
			menuOFM->AddItem(item);
		}

	BRect aRectOFM;
	aRectOFM.top  = 10;
	aRectOFM.left = 10+300+10;
	aRectOFM.right  = aRectOFM.left + 240;
	aRectOFM.bottom = aRectOFM.top  + 20;
	output_format_menu = new BMenuField(aRectOFM, "output_format_menu",
			"DnD format :", menuOFM);
	output_format_menu->SetDivider(70);

//--------------------------
//   Color Boxes
//

	BRect aRectSV1;
	aRectSV1.top  = 32;
	aRectSV1.left = 320;
	aRectSV1.right  = aRectSV1.left + 80;
	aRectSV1.bottom = aRectSV1.top  + 20;

	BStringView *fgcolor_label;
	fgcolor_label = new BStringView(aRectSV1, "fgcolor_label", "Foreground : ");

	BRect aRectSV2(aRectSV1);
	aRectSV2.OffsetBy(0,16);
	BStringView *bgcolor_label;
	bgcolor_label = new BStringView(aRectSV2, "bgcolor_label", "Background : ");

	BRect aRectSV3(aRectSV1);
	aRectSV3.OffsetBy(70,3);
	aRectSV3.InsetBy(4,4);
	aRectSV3.right  = aRectSV3.left + 30;	
	BMessage *messageCVfg = new BMessage(FONT_VIEW_COLOR_FG);
	this->fgcolor_box = new ColorView(aRectSV3, messageCVfg);
	this->fgcolor_box->SetColor(this->setting.fg_color);
	this->fgcolor_box->SetTarget(this);

	BRect aRectSV4(aRectSV2);
	aRectSV4.OffsetBy(70,3);
	aRectSV4.InsetBy(4,4);
	aRectSV4.right  = aRectSV4.left + 30;	
	BMessage *messageCVbg = new BMessage(FONT_VIEW_COLOR_BG);
	this->bgcolor_box = new ColorView(aRectSV4, messageCVbg);
	this->bgcolor_box->SetColor(this->setting.bg_color);
	this->bgcolor_box->SetTarget(this);


//----------------------
//   add upperView
//

	BRect aRectUV( aWindow->Bounds() );
	aRectUV.top += menubar->Frame().Height();
	aRectUV.bottom = FONT_WINDOW_UPPER_HEIGHT -1;

	rgb_color upper_view_bgcolor = ui_color(B_PANEL_BACKGROUND_COLOR);

	BView *upperView;
	upperView = new BView(aRectUV, "upper_view", B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW);
	upperView->SetViewColor(upper_view_bgcolor);
	upperView->AddChild(textControl);
	upperView->AddChild(textControl2);
	upperView->AddChild(button_fontsize_up);
	upperView->AddChild(button_fontsize_down);
	upperView->AddChild(output_format_menu);

	upperView->AddChild(fgcolor_label);
	upperView->AddChild(bgcolor_label);
	upperView->AddChild(fgcolor_box);
	upperView->AddChild(bgcolor_box);

	upperView->AddChild(slider);
	aWindow->AddChild(upperView);

//	this->fgcolor_box->SetViewColor(0,0,0);
//	this->bgcolor_box->SetViewColor(255,255,255);

	
//----------------------
//   add FontListView
//
	// set up a rectangle and instantiate a new view
	BRect aRect2( aWindow->Bounds() );
	aRect2.bottom -= B_H_SCROLL_BAR_HEIGHT;
	aRect2.right -= B_V_SCROLL_BAR_WIDTH;
	aRect2.top += FONT_WINDOW_UPPER_HEIGHT;

	BMessage *messageFV = new BMessage(FONT_SELECTED);

	aView = new FontView(aRect2, "FontView", "font_view", messageFV, fonts);
	aView->SetText(STARTUP_TEXT);
	aView->SetDrawingMode(B_OP_OVER);
	aView->SetHighColor(0,0,0);
	aView->SetLowColor(255,255,255);
	aView->SetViewColor(255,255,255);
		
	BScrollView *scrollView;
	scrollView = new BScrollView("scrollview1", aView, B_FOLLOW_ALL, B_NAVIGABLE, true, true, B_FANCY_BORDER);

	// popupmenu
	BPopUpMenu *popupmenu = new BPopUpMenu("font_popupmenu");
	{
		BMenuItem *item;
		
		item = new BMenuItem("Info",new BMessage(FONT_DISPLAY_INFO));
		item->SetTarget(this);
		popupmenu->AddItem(item);
		aView->SetPopUpMenu(popupmenu);
	}


//--------------------
//   Apply Display Setting
//
	aView->ApplySetting(&this->setting);

//--------------------
//   Color Control Window  (FG/BG)

	// Color Control FG
	BMessage *messageCC_fg = new BMessage(FONT_COLOR_CONTROL_MESSAGE_FG);
	color_control_FG = 
		new BColorControl(BPoint(0,0), B_CELLS_32x8, 6.0, 
			"fontworld color control fg",  messageCC_fg);
	color_control_FG->SetValue(this->setting.fg_color);

	// create window	
	float width,height;
	BRect color_control_window_FG_rect;
	color_control_FG->GetPreferredSize(&width, &height);
	color_control_FG->SetTarget(this);
	color_control_window_FG_rect.Set(0,0,width, height);
	color_control_window_FG_rect.OffsetTo(aWindow->ConvertToScreen(aRectSV3.LeftTop()) + BPoint(+60, 0));

	color_control_window_FG = 
		new BWindow(color_control_window_FG_rect
				, "Choose Foreground Color"
				, B_FLOATING_WINDOW_LOOK, B_FLOATING_APP_WINDOW_FEEL
				, B_ASYNCHRONOUS_CONTROLS | B_WILL_ACCEPT_FIRST_CLICK
				| B_NOT_ZOOMABLE | B_NOT_RESIZABLE
				| B_NOT_CLOSABLE
				);
	color_control_window_FG->AddChild(color_control_FG);

	// Color Control BG
	BMessage *messageCC_bg = new BMessage(FONT_COLOR_CONTROL_MESSAGE_BG);
	color_control_BG = 
		new BColorControl(BPoint(0,0), B_CELLS_32x8, 6.0, 
			"fontworld color control bg",  messageCC_bg);
	color_control_BG->SetValue(this->setting.bg_color);

	// create window	
	//float width,height;
	BRect color_control_window_BG_rect;
	color_control_BG->GetPreferredSize(&width, &height);
	color_control_BG->SetTarget(this);
	color_control_window_BG_rect.Set(0,0,width, height);
	
	color_control_window_BG_rect.OffsetTo(aWindow->ConvertToScreen(aRectSV4.LeftTop()) + BPoint(+60, +50));

	color_control_window_BG = 
		new BWindow(color_control_window_BG_rect
				, "Choose Background Color"
				, B_FLOATING_WINDOW_LOOK, B_FLOATING_APP_WINDOW_FEEL
				, B_ASYNCHRONOUS_CONTROLS | B_WILL_ACCEPT_FIRST_CLICK
				| B_NOT_ZOOMABLE | B_NOT_RESIZABLE
				| B_NOT_CLOSABLE
				);
	color_control_window_BG->AddChild(color_control_BG);

	//aWindow->AddToSubset(color_control_window_BG);??
	//color_control_window_BG->AddToSubset(aWindow);??


//--------------------
//   etc
//

	// add view to window
	aWindow->AddChild(scrollView);



	aWindow->SetSizeLimits(10,100000L,FONT_WINDOW_UPPER_HEIGHT + B_H_SCROLL_BAR_HEIGHT + 20,100000L);
	
	// make window visible
	aWindow->Show();
	

	scrollView->ScrollBar(B_VERTICAL)->SetSteps(FONT_ITEM_HEIGHT, FONT_ITEM_HEIGHT*5);


}

/*static */
void FontApplication::drawButtonBackground(BView *view, BRect &rect, bool is_on)
{
	rgb_color color_norm = ui_color(B_PANEL_BACKGROUND_COLOR);
	rgb_color color_light1 = tint_color(color_norm, B_LIGHTEN_1_TINT);
	rgb_color color_light2 = {255,255,255,255};
	//tint_color(color_norm, B_LIGHTEN_2_TINT);
	rgb_color color_dark1 = tint_color(color_norm, B_DARKEN_1_TINT);
	rgb_color color_dark2 = tint_color(color_norm, B_DARKEN_3_TINT);
	
	BRect rect_inside = rect;
	rect_inside.InsetBy(2,2);
	
	if (is_on)
	{
		view->SetHighColor(color_norm);
		view->FillRect(rect_inside, B_SOLID_HIGH);
		
		view->SetHighColor(color_light2);
		view->StrokeLine(rect.LeftBottom(), rect.LeftTop());
		view->StrokeLine(rect.LeftTop(), rect.RightTop());

		view->SetHighColor(color_dark2);
		view->StrokeLine(rect.RightTop(), rect.RightBottom());
		view->StrokeLine(rect.RightBottom(), rect.LeftBottom());
	}
	else
	{
		view->SetHighColor(color_dark1);
		view->FillRect(rect_inside, B_SOLID_HIGH);
		
		view->SetHighColor(color_dark2);
		view->StrokeLine(rect.LeftBottom(), rect.LeftTop());
		view->StrokeLine(rect.LeftTop(), rect.RightTop());

		view->SetHighColor(color_light2);
		view->StrokeLine(rect.RightTop(), rect.RightBottom());
		view->StrokeLine(rect.RightBottom(), rect.LeftBottom());
	}
	
}

void FontApplication::MessageReceived(BMessage *message)
{
#ifdef DEBUG
	printf("message received.\n");
#endif

	switch (message->what)
	{
/*	case B_SIMPLE_MESSAGE:
		aView->MessageReceived(message);
		break;
*/	case FONT_TEXT_CHANGE:
		if (aView != NULL && textControl != NULL)
		{
			aView->SetText(textControl->Text());
		}
		break;
		
	case FONT_TEXT_SIZE_UP:
		if (aView != NULL && slider != NULL)
		{
			int value = atoi(textControl2->Text());
			value ++;
			if (value <=0) value = 1;
			if (value >=1000) value = 1000;
			char stra[100];
			sprintf(stra,"%d",value);

			if (aView->Window()->Lock())
			{
				textControl2->SetText(stra);
				slider->SetValue(value);
				aView->Window()->Unlock();
			}
			aView->SetTextFontSize(value);
		}
		break;
	case FONT_TEXT_SIZE_DOWN:
		if (aView != NULL && slider != NULL)
		{
			int value = atoi(textControl2->Text());
			value --;
			if (value <=0) value = 1;
			if (value >=1000) value = 1000;
			char stra[100];
			sprintf(stra,"%d",value);

			if (aView->Window()->Lock())
			{
				textControl2->SetText(stra);
				slider->SetValue(value);
				aView->Window()->Unlock();
			}
			aView->SetTextFontSize(value);
		}
		break;
	case FONT_TEXT_SIZE_CHANGE:
		if (aView != NULL && slider != NULL)
		{
			char stra[100];
			sprintf(stra,"%ld",slider->Value());
			if (aView->Window()->Lock())
			{
				textControl2->SetText(stra);
				aView->Window()->Unlock();
			}
			aView->SetTextFontSize(slider->Value());
		}
		break;
		
	case FONT_TEXT_SIZE_CHANGE2:
		if (aView != NULL && slider != NULL)
		{
			int value = atoi(textControl2->Text());
			if (value <=0) value = 1;
			if (value >=1000) value = 1000;
			char stra[100];
			sprintf(stra,"%d",value);

			if (aView->Window()->Lock())
			{
				textControl2->SetText(stra);
				slider->SetValue(value);
				aView->Window()->Unlock();
			}
			aView->SetTextFontSize(value);
		}
		break;
		
	case FONT_DISPLAY_INFO:
		if (message->HasInt32("font_index"))
		{
			int32 index;
			if (message->FindInt32("font_index",0,&index) == B_OK)
			{
				BFont *font = aView->GetFontByIndex(index);
				if (font != NULL) this->DisplayFontInfo(font);
			}
		}
		break;
		
	case MENU_ANTIALIAS:
		if (message->HasPointer("source"))
		{
			void *pointer;
			if (message->FindPointer("source",0,&pointer) == B_OK)
			{
				BMenuItem *menuitem = (BMenuItem *)pointer;
				menuitem->SetMarked( ! menuitem->IsMarked() );

				// toggle antialiasing on/off
				aView->DisableAntialiasing(!menuitem->IsMarked());
			}
		}
		break;
		
	case MENU_SHOW_LINES:
		if (message->HasPointer("source"))
		{
			void *pointer;
			if (message->FindPointer("source",0,&pointer) == B_OK)
			{
				BMenuItem *menuitem = (BMenuItem *)pointer;
				menuitem->SetMarked( ! menuitem->IsMarked() );
				if (menuitem->IsMarked())
				{
					// (marked) :show lines
					aView->SetFontDrawingMode(
						aView->FontDrawingMode() 
						| FONTVIEW_SHOW_LINES_FLAG);
				}
				else
				{
					// (not marked) :disable lines
					aView->SetFontDrawingMode(
						aView->FontDrawingMode() 
						& ~FONTVIEW_SHOW_LINES_FLAG);
				}
			}
		}
		break;
	case MENU_ONLY_JAPANESE:
		if (message->HasPointer("source"))
		{
			void *pointer;
			if (message->FindPointer("source",0,&pointer) == B_OK)
			{
				BMenuItem *menuitem = (BMenuItem *)pointer;
				menuitem->SetMarked( ! menuitem->IsMarked() );
				if (menuitem->IsMarked())
				{
					// (marked) :only japanese
					pbfonts_stl_list::iterator it;
					it = fonts_lib -> begin();
					it++;
					pbfont_stl_vector &fonts = **it;
					aView->SetFonts(fonts);
				}
				else
				{
					// (not marked) :all fonts
					pbfont_stl_vector &fonts = **(fonts_lib->begin());
					aView->SetFonts(fonts);
				}
			}
		}
		break;
		
	case MENU_BITMAP_OUTPUT_FORMAT:
		const char *type;
		message->FindString("format", &type);
		aView->SetDnDOutputFormat(type);
		break;
	case MENU_SAVE_SETTING:
		SaveConfig();
		break;
	case MENU_LOAD_DEFAULT_SETTING:
		/*
		{
			FontDisplaySetting new_setting;
			this->setting = new_setting;
			
		}
		*/
		break;
		
	case FONT_VIEW_COLOR_FG: // toggle color choose window (fg)
		//printf("received: FONT_VIEW_COLOR_FG\n");
		if (color_control_window_FG->Lock())
		{
			if (color_control_window_FG->IsHidden())
			{
				if (aView->LockLooper())
				{
					color_control_window_FG->MoveTo(aView->ConvertToScreen(BPoint(440,-80)));
					aView->UnlockLooper();
				}
				color_control_window_FG->Show();
			}
			else
				color_control_window_FG->Hide();
			
			color_control_window_FG->Unlock();
		}
		break;
	case FONT_VIEW_COLOR_BG: // toggle color choose window (bg)
		//printf("received: FONT_VIEW_COLOR_BG\n");
		if (color_control_window_BG->Lock())
		{
			if (color_control_window_BG->IsHidden())
			{
				if (aView->LockLooper())
				{
					color_control_window_BG->MoveTo(aView->ConvertToScreen(BPoint(440,0)));
					aView->UnlockLooper();
				}
				color_control_window_BG->Show();
			}
			else
				color_control_window_BG->Hide();
			
			color_control_window_BG->Unlock();
		}
		break;
	case FONT_COLOR_CONTROL_MESSAGE_FG: // color choosed! (fg)
		{
			rgb_color new_color = this->color_control_FG->ValueAsColor();
			this->fgcolor_box->SetColor(new_color);
			this->aView->SetFGColor(new_color);
		}
		break;
	case FONT_COLOR_CONTROL_MESSAGE_BG: // color choosed! (bg)
		{
			rgb_color new_color = this->color_control_BG->ValueAsColor();
			this->bgcolor_box->SetColor(new_color);
			this->aView->SetBGColor(new_color);
		}
		break;
	}
	
}

void FontApplication::DisplayFontInfo(BFont *font)
{
	static char stra[1000];
	static char strb[300];
	stra[0] = '\0';

	

	strcat (stra, "< Font Information >\n\n");
	
	
	// get family & style
	font_family family;
	font_style style;
	font->GetFamilyAndStyle(&family, &style);
	sprintf(strb, 
			"Family    : %s\n"
			"Style     : %s\n"
			"Size      : %6.2f\n", family, style, font->Size());
	strcat(stra,strb);
	
	// ascent & descent & leading	
	font_height fontheight;
	font->GetHeight(&fontheight);

	sprintf(strb, 
			"Ascent    : %6.2f\n"
			"Descent   : %6.2f\n"
			"Leading   : %6.2f\n", fontheight.ascent, fontheight.descent, fontheight.leading);
	strcat(stra,strb);

	
	char direction[50] = "";
	switch (font->Direction())
	{
	case B_FONT_LEFT_TO_RIGHT:
		strcpy(direction, "left to right");
		break;
	case B_FONT_RIGHT_TO_LEFT:
		strcpy(direction, "right to left");
		break;
	}
	sprintf(strb, 
			"Direction : %s\n", direction);
	strcat(stra,strb);

	sprintf(strb, 
			"Flags     : 0x%lx\n"
			"Shear     : %6.2f\n"
			"Rotation  : %6.2f\n", font->Flags(), font->Shear(), font->Rotation());
	strcat(stra,strb);
	
	// spacing
	char spacing[50] = "";
	switch (font->Spacing())
	{
	case B_CHAR_SPACING:
		strcpy(spacing,"B_CHAR_SPACING");
		break;
	case B_STRING_SPACING:
		strcpy(spacing,"B_STRING_SPACING");
		break;
	case B_BITMAP_SPACING:
		strcpy(spacing,"B_BITMAP_SPACING");
		break;
	case B_FIXED_SPACING:
		strcpy(spacing,"B_FIXED_SPACING");
		break;
	
	}

	sprintf(strb, 
			"Spacing   : %s\n", spacing);
	strcat(stra,strb);

	sprintf(strb, 
			"Face      : 0x%x\n"
			"String width  : %6.2f\n", font->Face(), font->StringWidth(aView->Text()));
	strcat(stra,strb);

/*
	// tuned fonts
	int tuned_fonts_num = 0;
	tuned_fonts_num = font->CountTuned();
	sprintf(strb, 
			"Tuned (bitmap) fonts num : %d\n" , tuned_fonts_num);			
	strcat(stra,strb);

	for (int i=0 ; i<tuned_fonts_num ; i++)
	{
		tuned_font_info tuned_info;
		font->GetTunedInfo( i, &tuned_info);
		sprintf(strb,
				"	%d. size: %6.2f\n" , i+1, tuned_info.size);
		strcat(stra,strb);
	}
*/
	BAlert *alert = new BAlert("About This Font"
		, stra
		, "OK");
	alert->TextView()->SetFont(be_fixed_font); 
	alert->Go();

}

void FontApplication::AboutRequested(void)
{
	BAlert *alert = new BAlert("About FontWorld",
		 " FontWorld version" VERSION_STRING " (" UPDATE_DATE_STRING ")\n"
		 "\n"
		 "Font Displaying Utility for BeOS R5\n"
		 "Produced by HAMANAKA Makoto\n"
		 "\n"
		 "***IMPORTANT***\n"
		 "To run this application smoothly, "
		 "please launch \"Fonts\" program in "
		 "the \"preferences\" folder in the deskbar, "
		 "and change your system's \"Screen font cache size\" "
		 "to over 1 or 2MB. \n"
		, "OK"); 
	alert->Go();
}
   

void count_fonts2(pbfont_stl_vector &fonts)
{
	update_font_families(false);
	int32 numFamilies = count_font_families(); 
	for ( int32 i = 0; i < numFamilies; i++ ) { 
		// count families
       font_family family; 
       uint32 flags; 
       if ( get_font_family(i, &family, &flags) == B_OK ) { 
           // find one family
           int32 numStyles = count_font_styles(family); 
           for ( int32 j = 0; j < numStyles; j++ ) { 
           		// count styles
               font_style style; 
               if ( get_font_style(family, j, &style, &flags) 
                                                 == B_OK ) {
                   BFont *font = new BFont();
                   font->SetFamilyAndStyle(family, style);
                   fonts.push_back(font);
               }
           } 
       } 
   }
}

void count_fonts_only_japanese(pbfont_stl_vector &fonts)
{
	update_font_families(false);
	int32 numFamilies = count_font_families(); 
	for ( int32 i = 0; i < numFamilies; i++ ) { 
		// count families
       font_family family; 
       uint32 flags; 
       if ( get_font_family(i, &family, &flags) == B_OK ) { 
           // find one family
           int32 numStyles = count_font_styles(family); 
           for ( int32 j = 0; j < numStyles; j++ ) { 
           		// count styles
               font_style style; 
               if ( get_font_style(family, j, &style, &flags) 
                                                 == B_OK ) {
                   BFont *font = new BFont();
                   if (font->Blocks().Includes(B_HIRAGANA_BLOCK))
                   {
	                   font->SetFamilyAndStyle(family, style);
	                   fonts.push_back(font);
	                   printf("has hiragana unicode block");
	               }
	               else
	               {
	                   printf("no hiragana unicode block");
	               		delete font;
	               }
               }
           } 
       } 
   }
}

void FontApplication::InitTranslators()
{
	//	Find the translator to use for us
	translator_id * all_translators = NULL;
	int32 count = 0;
	status_t err = BTranslatorRoster::Default()->GetAllTranslators(&all_translators, &count);
	if (err >= B_OK) {
//		this->all_translators_num = count;

		err = B_ERROR;
		//	look through all available translators
		for (int ix=0; ix<count; ix++) {
			const translation_format * in_formats;
			int32 fmt_count;
			if (B_OK <= BTranslatorRoster::Default()->GetInputFormats(all_translators[ix],
					&in_formats, &fmt_count)) {
				//	look for translators that accept BBitmaps as input
				for (int iy=0; iy<fmt_count; iy++) {
					if (in_formats[iy].type == B_TRANSLATOR_BITMAP) {
						goto do_this_format;
					}
				}
			}
			continue;
do_this_format:
			const translation_format * out_formats;
			if (B_OK <= BTranslatorRoster::Default()->GetOutputFormats(all_translators[ix],
					&out_formats, &fmt_count)) {
				//	look through the output formats
				for (int iy=0; iy<fmt_count; iy++) {
					printf("format = %s\n",out_formats[iy].MIME);
					string type(out_formats[iy].MIME);

					// add entry to map (key,value) = (mimetype, translaor)
					this->translators_map.insert(
						make_pair(type, make_pair(all_translators[ix], out_formats[iy].type)));

					printf("translator_id = %ld\n", all_translators[ix]);
					printf("translator_code = %ld\n", out_formats[iy].type);
					
/*					if (strcmp(out_formats[iy].MIME, "image/x-targa") == 0)
					{
						translator = all_translators[ix];
						translator_type_code = out_formats[iy].type;
						strcpy(translator_type_string, out_formats[iy].MIME);
						err = B_OK;
						break;
					}
*/					
					//	and take the first output format that isn't BBitmap
/*
					if (out_formats[iy].type != B_TRANSLATOR_BITMAP) {
						translator = all_translators[ix];
						translator_type_code = out_formats[iy].type;
						strcpy(translator_type_string, out_formats[iy].MIME);
						err = B_OK;
						break;
					}
*/
				}
			}
		}
	}
	delete[] all_translators;
	if (err < B_OK) {
	}
	MimetypeTranslatorMap::iterator it;
	for (it = translators_map.begin() ; it != translators_map.end() ; it++)
	{
		printf("translator: %s\n", (it->first).c_str());
	}
}

#ifndef _PATH_H
#include "Path.h" 
#endif
#ifndef _FIND_DIRECTORY_H
#include "FindDirectory.h"
#endif

void FontApplication::LoadConfig()
{
	FontWorldConfig config;
	BPath path;
	status_t status;

	status = find_directory(B_COMMON_SETTINGS_DIRECTORY, &path); 
	if (status != B_OK)
	{
		printf("setting directory not found\n");
		return;
	}
	
	BString config_file_locaion;
	config_file_locaion.SetTo(path.Path());
	config_file_locaion += "/" FONTWORLD_CONFIG_FILENAME;
	
	printf("config file location = %s\n", config_file_locaion.String());

	config.SetConfigFileLocation(config_file_locaion);

	status = config.Load();
	if (status != B_OK)
	{
		printf("config.Load() error\n");
		return;
	}

	/* unfold settings */
	if (config.Lock())
	{
		int32 settings_num = 0;
		status = config.CountSettings(&settings_num);
		if (status != B_OK)
		{
			printf("config.CountSettings() error\n");
			config.Unlock();
			return;
		}
		printf("::LoadConfig() settings_num = %ld\n", settings_num);
		for (int i=0 ; i<settings_num ; i++)
		{
			printf("found setting name : <%s>\n",config.SettingNameAt(i).String());
			if (config.SettingNameAt(i) == "__default_setting__")
			{
				this->setting = *config.SettingAt(i);
				printf("%s\n", this->setting.ToString().String());
			}
		}
		this->setting.SetSettingName("__default_setting__");

		config.Unlock();
	}
}

bool FontApplication::QuitRequested(void)
{
//	this->SaveConfig();
	return true;
}

void FontApplication::SaveConfig()
{
	FontWorldConfig config;
	BPath path;
	status_t status;

	status = find_directory(B_COMMON_SETTINGS_DIRECTORY, &path); 
	if (status != B_OK)
	{
		printf("setting directory not found\n");
		return;
	}
	
	BString config_file_locaion;
	config_file_locaion.SetTo(path.Path());
	config_file_locaion += "/" FONTWORLD_CONFIG_FILENAME;
	
	printf("config file location = %s\n", config_file_locaion.String());

	config.SetConfigFileLocation(config_file_locaion);

	this->aView->StoreSetting(&this->setting);
	this->setting.SetSettingName("__default_setting__");

	/*
	setting1.fg_color = make_rgb_color(60,50,40);
	setting1.bg_color = make_rgb_color(1,2,3);
	setting1.enable_display_lines = false;
	setting1.enable_antialiasing = true;
	setting1.black_white_mode = false;
	setting1.font_size = 100.0;
	*/

	status = config.AddSetting(&this->setting);
	if (status != B_OK)
	{
		printf("config.AddSetting() error\n");
		return;
	}

	status = config.Update();
	if (status != B_OK)
	{
		printf("config.Update() error\n");
		return;
	}
}
