/*
	
	FontWorld.h
	
	Copyright 1998 HAMANAKA Makoto, All Rights Reserved.

*/
//#define MALLOC_DEBUG

#ifndef FONT_WORLD_H
#define FONT_WORLD_H

#ifndef _APPLICATION_H
#include <Application.h>
#endif

#include <InterfaceKit.h>

#ifndef _FONT_H
#include <Font.h>
#endif
#ifndef _COLOR_CONTROL_H
#include <ColorControl.h>
#endif

#include <TranslationUtils.h> 


//#define MSIPL_USING_NAMESPACE

#ifndef FONT_DISPLAY_SETTING_H
#include "FontDisplaySetting.h"
#endif
#ifndef COLOR_VIEW_H
#include "ColorView.h"
#endif

#include <algorithm>
#include <vector>
#include <list>
#include <map>
#include <string>

using namespace std;



#define VERSION_STRING "0.561"
#define UPDATE_DATE_STRING "2000/08/23"

#define FONT_WINDOW_UPPER_HEIGHT 92

#define FONT_TEXT_CHANGE  'fwTC'
#define FONT_TEXT_SIZE_CHANGE 'fwSC'
#define FONT_TEXT_SIZE_CHANGE2 'fwS2'
#define FONT_TEXT_SIZE_UP 'fwSU'
#define FONT_TEXT_SIZE_DOWN 'fwSD'
#define FONT_SELECTED 'fwSL'
#define FONT_DISPLAY_INFO 'fwDI'
#define MENU_ANTIALIAS 'fwAT'
#define MENU_SHOW_LINES 'fwSL'
#define MENU_ONLY_JAPANESE 'fwOJ'
#define MENU_BITMAP_OUTPUT_FORMAT 'fwOF'
#define MENU_BACKGROUND_SELECT 'fwBS'
#define MENU_SAVE_SETTING 'fwSS'
#define MENU_LOAD_DEFAULT_SETTING 'fwDS'
#define FONT_VIEW_COLOR_FG 'fwFG'
#define FONT_VIEW_COLOR_BG 'fwBG'
#define FONT_COLOR_CONTROL_MESSAGE_FG 'fwCF'
#define FONT_COLOR_CONTROL_MESSAGE_BG 'fwCB'

#define FONTWORLD_CONFIG_FILENAME "fontworld_setting"

#define STARTUP_TEXT "FontWorld For BeOS!"

typedef vector <BFont *, allocator < BFont * > > pbfont_stl_vector;
typedef list <pbfont_stl_vector *,
	allocator < pbfont_stl_vector * > >
	pbfonts_stl_list;
typedef multimap<string, pair<translator_id, int32> > MimetypeTranslatorMap;

class FontView;

class FontApplication : public BApplication 
{
	FontView	*aView;
	BTextControl *textControl;
	BTextControl *textControl2;
	BSlider *slider;
	BMenuField *output_format_menu;
	pbfonts_stl_list *fonts_lib;
	FontDisplaySetting setting;
	ColorView *fgcolor_box;
	ColorView *bgcolor_box;

	
	BWindow *color_control_window_FG;
	BWindow *color_control_window_BG;
	BColorControl *color_control_FG;
	BColorControl *color_control_BG;

	void DisplayFontInfo(BFont *font);
	static void drawButtonBackground(BView *view, BRect &rect, bool is_on);

	virtual void LoadConfig();
	virtual void SaveConfig();

public:
	MimetypeTranslatorMap translators_map;
	FontApplication();
	virtual ~FontApplication();
	virtual void MessageReceived(BMessage *message);
	virtual void AboutRequested(void);
	virtual void InitTranslators();
	virtual bool QuitRequested(void);
};

extern FontApplication	*myApp;

#endif //FONT_WORLD_H
