/*
	
	FontWorldConfig.h
	
	Copyright 1998 HAMANAKA Makoto , All Rights Reserved.
	
*/

#ifndef FONT_WORLD_CONFIG_H
#define FONT_WORLD_CONFIG_H

#ifndef FONT_DISPLAY_SETTING_H
#include "FontDisplaySetting.h"
#endif

#ifndef _LOCKER_H
#include <Locker.h>
#endif
#ifndef _LIST_H
#include <List.h>
#endif
#ifndef _STRING_H
#include <String.h>
#endif

//#define MAX_HISTORY_SIZE 100

class FontWorldConfig 
{
private:
//	BMessage config_storage;
	BString configfile_path;
	BList settings;
	BList display_history_strings;
//	BString display_string_history[MAX_HISTORY_SIZE];

/*	bool enable_display_lines;
	bool enable_antialiasing;
	bool black_white_mode;
	uint32 font_size;
	rgb_color fg_color;
	rgb_color bg_color;
*/
	BLocker locker;
	

public:
	FontWorldConfig();
	
	status_t Lock()
	{
		return locker.Lock();
	}
	
	void Unlock()
	{
		 locker.Unlock();
	}
	void SetConfigFileLocation(BString _path)
	{
		this->Lock();
		this->configfile_path = _path;
		this->Unlock();
	};
	status_t Update();
	status_t Load();
	//status_t Save(char *path);
	
	//BString display_string_history[MAX_HISTORY_SIZE];
/*
	void SetStringHistoryItem(uint32 index, BString string);
	void GetStringHistoryItem(uint32 index, BString *string);
	uint32 GetStringHistoryItemsNum();
	uint32 SetStringHistoryItemsNum();
*/
	status_t AddSetting(FontDisplaySetting *_setting);
	status_t RemoveSetting(FontDisplaySetting *_setting);
	status_t GetSetting(BString name, FontDisplaySetting **setting);
	
	status_t CountSettings(int32 *settings_num);
	FontDisplaySetting * SettingAt(int32 index);
	BString SettingNameAt(int32 index);
	
	static void test(void);

/*
	//bool enable_display_lines;
	void SetBool_EnableDisplayLines(bool value);
	bool GetBool_EnableDisplayLines();
	//bool enable_antialiasing;
	void SetBool_EnableAntialiasing(bool value);
	bool GetBool_EnableAntialiasing();
	//uint32 font_size;
	void SetFontSize(uint32 font_size);
	void GetFontSize();
	
	//rgb_color fg_color;
	//rgb_color bg_color;
*/
//				FontWindow(BRect frame); 
//virtual	bool	QuitRequested();
};

#endif //FONT_WORLD_CONFIG_H
