/*
	
	rgb_color_util.cpp
	
	Copyright 2000 HAMANAKA Makoto , All Rights Reserved.
	
*/

#ifndef RGB_COLOR_UTIL_H
#include "rgb_color_util.h"
#endif

rgb_color make_rgb_color( uint8 r, uint8 g, uint8 b, uint8 a = 255 )
{ 
	rgb_color rgba; 
	rgba.red = r; 
	rgba.green = g; 
	rgba.blue = b; 
	rgba.alpha = a; 
	return rgba; 
}

uint32 make_uint32_from_rgb_color(rgb_color &rgba)
{ 
	return (rgba.red << 24 |
	rgba.green << 16 |
	rgba.blue << 8 |
	rgba.alpha);
}

rgb_color make_rgb_color_from_uint32(uint32 color)
{ 
	rgb_color rgba; 
	rgba.red = (color >> 24) & 0xff; 
	rgba.green = (color >> 16) & 0xff; 
	rgba.blue = (color >> 8) & 0xff; 
	rgba.alpha = color & 0xff; 
	return rgba; 
}

BString rgb_color_to_string(rgb_color &rgba)
{
	BString string;

	string << "rgb_color "
			       "red[" << (int)rgba.red
			<< "] green[" << (int)rgba.green
			<< "]  blue[" << (int)rgba.blue
			<< "] alpha[" << (int)rgba.alpha << "]";
	return string;
}

